package com.fp.persistence.parmas.soli;

import javax.persistence.Entity;
import javax.persistence.Id;
import javax.persistence.Column;
import javax.persistence.EntityManager;

import java.io.Serializable;

import javax.persistence.Table;

import com.fp.dto.hb.HibernateBean;
import com.fp.dto.hb.Log;

import javax.persistence.Version;

import java.lang.reflect.Field;

import javax.persistence.Transient;

import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TARMINSPECCION*/
@Entity(name="TarmInspeccion")
@Table(name="TARMINSPECCION")
public class TarmInspeccion extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable, Log {
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TarmInspeccion
*/
@Id
@Column(name="CINSPECCION" ,nullable=false, updatable=false)
private Long pk;
@Column(name="APLICADECOMISO", nullable=true)

/**
* si el tramite se niega, el campo es para validar si aplica decomiso
*/
private String aplicadecomiso;

@Column(name="CSOLICITUD", nullable=true)

/**
* Codigo de solicitud de controld e armas
*/
private String csolicitud;

@Column(name="PERSONCODE", nullable=true)

/**
* Codigo de persona responsable de la inspeccion
*/
private Integer personcode;

@Column(name="CTRAMITE", nullable=true)

/**
* código de la tabla de tramite
*/
private Long ctramite;

@Column(name="TRAMITEPROCESO", nullable=true)

/**
* campo para validar si el tramite o proceso continua
*/
private String tramiteproceso;

@Column(name="OBSERVACION", nullable=true)

/**
* campo de observación de la inspección
*/
private String observacion;

@Column(name="FECHAREGISTRO", nullable=true)

/**
* fecha de registro de la inspección
*/
private Date fecharegistro;

@Column(name="NUMORDENTRABAJO", nullable=true)

/**
* null
*/
private String numordentrabajo;

@Column(name="CSITIOALMACENAMIENTO", nullable=true)

/**
* código de la tabla de sitios de almacenamiento
*/
private String csitioalmacenamiento;

@Column(name="CPLANIFICACIONTRAMITE", nullable=true)

/**
* codigo de la tabla de planificacion tramite, codigo de la planificacion de la inspeccion
*/
private Long cplanificaciontramite;

@Column(name="PLANIFICADO", nullable=true)

/**
* campo para validar si es el registro de una inspeccion planificada o no planificada
*/
private String planificado;

@Column(name="CENTROCONTROL", nullable=true)

/**
* centro de control al que pertenece la persona que realiza el tramite
*/
private String centrocontrol;

@Column(name="ANNO", nullable=true)

/**
* null
*/
private Long anno;

/**Contructor por defecto*/
public TarmInspeccion(){
}
/**Contructor de TarmInspeccion
@param pPk Clave Primaria del entity
*/
public TarmInspeccion(Long pPk){
 this();
 pk=pPk;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TarmInspeccion
*/
public static TarmInspeccion find(EntityManager pEntityManager,Object pKey) throws Exception{
    TarmInspeccion obj = pEntityManager.find(TarmInspeccion.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TarmInspeccion
@return El objeto que referencia a la Clave primaria de TarmInspeccion
*/
public Long getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TarmInspeccion
@param pPk El objeto que referencia a la nueva Clave primaria de TarmInspeccion
*/
public void setPk(Long pPk){
  pk=pPk;
}
/**Obtiene el valor de aplicadecomiso
@return valor de aplicadecomiso*/
public String getAplicadecomiso(){
  return aplicadecomiso;
}
/**Fija el valor de aplicadecomiso
@param pAplicadecomiso nuevo Valor de aplicadecomiso*/
public void setAplicadecomiso(String pAplicadecomiso){
  aplicadecomiso=pAplicadecomiso;
}

/**Obtiene el valor de csolicitud
@return valor de csolicitud*/
public String getCsolicitud(){
  return csolicitud;
}
/**Fija el valor de csolicitud
@param pCsolicitud nuevo Valor de csolicitud*/
public void setCsolicitud(String pCsolicitud){
  csolicitud=pCsolicitud;
}

/**Obtiene el valor de personcode
@return valor de personcode*/
public Integer getPersoncode(){
  return personcode;
}
/**Fija el valor de personcode
@param pPersoncode nuevo Valor de personcode*/
public void setPersoncode(Integer pPersoncode){
  personcode=pPersoncode;
}

/**Obtiene el valor de ctramite
@return valor de ctramite*/
public Long getCtramite(){
  return ctramite;
}
/**Fija el valor de ctramite
@param pCtramite nuevo Valor de ctramite*/
public void setCtramite(Long pCtramite){
  ctramite=pCtramite;
}

/**Obtiene el valor de tramiteproceso
@return valor de tramiteproceso*/
public String getTramiteproceso(){
  return tramiteproceso;
}
/**Fija el valor de tramiteproceso
@param pTramiteproceso nuevo Valor de tramiteproceso*/
public void setTramiteproceso(String pTramiteproceso){
  tramiteproceso=pTramiteproceso;
}

/**Obtiene el valor de observacion
@return valor de observacion*/
public String getObservacion(){
  return observacion;
}
/**Fija el valor de observacion
@param pObservacion nuevo Valor de observacion*/
public void setObservacion(String pObservacion){
  observacion=pObservacion;
}

/**Obtiene el valor de fecharegistro
@return valor de fecharegistro*/
public Date getFecharegistro(){
  return fecharegistro;
}
/**Fija el valor de fecharegistro
@param pFecharegistro nuevo Valor de fecharegistro*/
public void setFecharegistro(Date pFecharegistro){
  fecharegistro=pFecharegistro;
}

/**Obtiene el valor de numordentrabajo
@return valor de numordentrabajo*/
public String getNumordentrabajo(){
  return numordentrabajo;
}
/**Fija el valor de numordentrabajo
@param pNumordentrabajo nuevo Valor de numordentrabajo*/
public void setNumordentrabajo(String pNumordentrabajo){
  numordentrabajo=pNumordentrabajo;
}

/**Obtiene el valor de csitioalmacenamiento
@return valor de csitioalmacenamiento*/
public String getCsitioalmacenamiento(){
  return csitioalmacenamiento;
}
/**Fija el valor de csitioalmacenamiento
@param pCsitioalmacenamiento nuevo Valor de csitioalmacenamiento*/
public void setCsitioalmacenamiento(String pCsitioalmacenamiento){
  csitioalmacenamiento=pCsitioalmacenamiento;
}

/**Obtiene el valor de cplanificaciontramite
@return valor de cplanificaciontramite*/
public Long getCplanificaciontramite(){
  return cplanificaciontramite;
}
/**Fija el valor de cplanificaciontramite
@param pCplanificaciontramite nuevo Valor de cplanificaciontramite*/
public void setCplanificaciontramite(Long pCplanificaciontramite){
  cplanificaciontramite=pCplanificaciontramite;
}

/**Obtiene el valor de planificado
@return valor de planificado*/
public String getPlanificado(){
  return planificado;
}
/**Fija el valor de planificado
@param pPlanificado nuevo Valor de planificado*/
public void setPlanificado(String pPlanificado){
  planificado=pPlanificado;
}
/**
 * @return the centrocontrol
 */
public String getCentrocontrol() {
	return centrocontrol;
}
/**
 * @param centrocontrol the centrocontrol to set
 */
public void setCentrocontrol(String centrocontrol) {
	this.centrocontrol = centrocontrol;
}
/**
 * @return the anno
 */
public Long getAnno() {
	return anno;
}
/**
 * @param anno the anno to set
 */
public void setAnno(Long anno) {
	this.anno = anno;
}
public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TarmInspeccion))return false;
    TarmInspeccion that = (TarmInspeccion) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TarmInspeccion
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TarmInspeccion
*/
public Object createInstance(){
 TarmInspeccion instance=new TarmInspeccion();	
 return instance;
}
/**Clona la entidad TarmInspeccion
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TarmInspeccion p=(TarmInspeccion)this.clone();
  return p;
}
}
